/*
* Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
* Copyright (C) 2015 - Scilab Enterprises - Cedric DELAMARRE
*
* This file must be used under the terms of the CeCILL.
* This source file is licensed as described in the file COPYING, which
* you should have received as part of this distribution.  The terms
* are also available at
* http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
*
*/

__kernel void computeFract(__global double* xvect, __global double* yvect, int xsize, int ysize, int nmax, __global double* output)
{
    int i  = get_global_id(0);
    int j  = get_global_id(1);
    double x, xtemp, y, x0, y0, xx, yy;
    int k = 0;

    x  = xvect[i];
    y  = yvect[j];
    x0 = x;
    y0 = y;
    xx = x*x;
    yy = y*y;

    while((xx + yy) < 4 && k < nmax )
    {
        y   = 2 * x * y + y0;
        x   = xx - yy + x0;
        xx  = x * x;
        yy  = y * y;
        k++;
    }

    output[ j + i * xsize ] = (double)k;
}
