/*
* Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
* Copyright (C) 2015 - Scilab Enterprises - Cedric DELAMARRE
*
* This file must be used under the terms of the CeCILL.
* This source file is licensed as described in the file COPYING, which
* you should have received as part of this distribution.  The terms
* are also available at
* http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
*
*/

/* Matrix transpose with OpenCL
* Device code.
*/

#include "config_gpu.h"
#ifdef WITH_Nvidia
#pragma OPENCL EXTENSION cl_khr_fp64: enable
#endif

__kernel void transpose_naive(__global double *odata, __global double* idata, int width, int height)
{
   int xIndex = get_global_id(0);
   int yIndex = get_global_id(1);

   if (xIndex < width && yIndex < height)
   {
       int index_in  = yIndex + height * xIndex;
       int index_out = xIndex + width * yIndex;
       odata[index_out] = idata[index_in];
   }
}
