/*
* Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
* Copyright (C) Scilab Enterprises - 2014 - Cedric DELAMARRE
*
* This file must be used under the terms of the CeCILL.
* This source file is licensed as described in the file COPYING, which
* you should have received as part of this distribution.  The terms
* are also available at
* http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
*
*/

#include "config_gpu.h"
#ifdef WITH_Nvidia
#pragma OPENCL EXTENSION cl_khr_fp64: enable
#endif

__kernel void convertToCLcomplex(__global double* d, int rows, int cols, __global double2* d_data)
{
    int x = get_global_id(0);
    int y = get_global_id(1);
    int pos = y*cols+x;

    if((x < cols) && (y < rows))
    {
        d_data[pos].x=d[pos];
        d_data[pos].y=0;
    }
}

__kernel void writeToCLcomplex(__global double* d, __global double* di, int rows, int cols, __global double2* d_data)
{
    int x = get_global_id(0);
    int y = get_global_id(1);
    int pos = y*cols+x;

    if((x < cols) && (y < rows))
    {
        d_data[pos].x=d[pos];
        d_data[pos].y=di[pos];
    }
}

__kernel void readInCLcomplex(__global double* d, __global double* di, int rows, int cols, __global double2* d_data)
{
    int x = get_global_id(0);
    int y = get_global_id(1);
    int pos = y*cols+x;

    if((x < cols) && (y < rows))
    {
        d[pos]=d_data[pos].x;
        di[pos]=d_data[pos].y;
    }
}
