/*
* Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
* Copyright (C) Scilab Enterprises - 2014 - Cedric DELAMARRE
*
* This file must be used under the terms of the CeCILL.
* This source file is licensed as described in the file COPYING, which
* you should have received as part of this distribution.  The terms
* are also available at
* http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
*
*/

#include "config_gpu.h"
#ifdef WITH_Nvidia
#pragma OPENCL EXTENSION cl_khr_fp64: enable
#endif

__kernel void transpose(__global double *odata, __global double* idata, int width, int height)
{
    unsigned int xIndex = get_global_id(0);
    unsigned int yIndex = get_global_id(1);

    if (xIndex < width && yIndex < height)
    {
        unsigned int index_in  = yIndex + height * xIndex;
        unsigned int index_out = xIndex + width * yIndex;
        odata[index_out] = idata[index_in];
    }
}
__kernel void transposeZ(__global double2 *odata, __global double2 *idata, int width, int height)
{
    unsigned int xIndex = get_global_id(0);
    unsigned int yIndex = get_global_id(1);

    if (xIndex < width && yIndex < height)
    {
        unsigned int index_in  = yIndex + height * xIndex;
        unsigned int index_out = xIndex + width * yIndex;
        odata[index_out].x = idata[index_in].x;
        odata[index_out].y = -idata[index_in].y;
    }
}
