/*
* Scilab ( http://www.scilab.org/ ) - This file is part of Scilab
* Copyright (C) Scilab Enterprises - 2014 - Cedric DELAMARRE
*
* This file must be used under the terms of the CeCILL.
* This source file is licensed as described in the file COPYING, which
* you should have received as part of this distribution.  The terms
* are also available at
* http://www.cecill.info/licences/Licence_CeCILL_V2-en.txt
*
*/

#include "config_gpu.h"
#ifdef WITH_Nvidia
#pragma OPENCL EXTENSION cl_khr_fp64: enable
#endif

//!\ ********** Warning *********** /!\
//!\ result must be initialise to 1 /!\
//!\ before calling this kernel     /!\
//!\ ****************************** /!\

__kernel void strictIncreasing_kernel(__global double* data, int size, __global int* result)
{
    unsigned int xIndex = get_global_id(0);
    if(xIndex < size-1 && data[xIndex] >= data[xIndex+1])
    {
        *result = 0;
    }
}
